﻿using System.Diagnostics;
using System.Drawing;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;

namespace UltraGridBUPrototype
{
    public class CreatingUiElement : IUIElementCreationFilter
    {
        public void AfterCreateChildElements(UIElement parent)
        {
            var el = parent as HeaderUIElement;

            if (el != null)
            {
                var newButton = new ButtonUIElement(el)
                {
                    Text = "X",
                    Rect = new Rectangle(el.Rect.X + el.Rect.Width - 20, el.Rect.Y, 18, 18)
                };

                el.ChildElements.Add(newButton);
                newButton.ElementClick += NewButtonElementClick;
            }
        }

        static void NewButtonElementClick(object sender, UIElementEventArgs e)
        {
            var buttonUiElement = e.Element as ButtonUIElement;

            var headerUiElement = buttonUiElement.Parent as HeaderUIElement;

            var bandHeadersUiElement = headerUiElement.Parent as BandHeadersUIElement;

            var rowColRegionIntersectionUiElement = bandHeadersUiElement.Parent as RowColRegionIntersectionUIElement;

            foreach (var v in rowColRegionIntersectionUiElement.ChildElements)
            {
                if (v is RowUIElement)
                {
                    var rowUiElement = v as RowUIElement;


                    Debug.WriteLine("RowUIElement: " + rowUiElement);
                    Debug.WriteLine("Row: " + rowUiElement.Row);
                    Debug.WriteLine("ListObject: " + rowUiElement.Row.ListObject);
                }
            }

            var dataAreaUiElement = rowColRegionIntersectionUiElement.Parent as DataAreaUIElement;
            var ultraGridUiElement = dataAreaUiElement.Parent as UltraGridUIElement;

            Debug.WriteLine(ultraGridUiElement.ToString());
        }

        public bool BeforeCreateChildElements(UIElement parent)
        {
            return false;
        }
    }
}